#ifndef _ACTS1001_DEVICE_
#define _ACTS1001_DEVICE_

#define ACTS1001_AD_MAX_CHANNELS	4 // ֧4·ģͨİ忨
//######################## ְ֧忨 #################################
// PXIE/PCIE 8533B 4CH 12Bit 80Msps
// PXIE/PCIE 8534B 4CH 14Bit 80Msps
// PXIE/PCIE 8543B 4CH 12Bit 40Msps
// PXIE/PCIE 8544B 4CH 14Bit 40Msps
// PXIE/PCIE 8531B 2CH 14Bit 20Msps,֧ʱ,֧ⲿ10M,ִ֧
// PXIE/PCIE 8532B 2CH 12Bit 20Msps,֧ʱ,֧ⲿ10M,ִ֧

//***********************************************************
// ADʵӲ
typedef struct _ACTS1001_PARA_AD     
{
	LONG bChannelArray[4];	// ͨѡ,ֱ4ͨ,=TRUEʾͨ,򲻲(ֻ֧3ͨ:0 01 0123)
	LONG InputRange[4];		// ģѡ
	LONG CouplingType[4];	// (ֱ, )
	LONG FreqDivision;      // Ƶ[1, 2147483647],ʱ:Ƶ=ⲿʱƵ/Ƶ;ʱ:Ƶ=׼Ƶ/Ƶ;
	LONG DelaySamps;        // ʱʱΧ[0, 2147483647]
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerType;		// 
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TrigLevelVolt;		// ƽ(̰ģ)
	LONG TrigWindow;		// λnS,Ϊ߲ʵĲ;80M,Ϊ12.5nS
	LONG ReferenceClock;	// οʱѡ
	LONG TimeBaseClock;		// ʱѡ
	LONG bMasterEn;			// 豸ʹ  
							// =0豸,豸͵ͬź
							// =1豸,Ϊ豸Ĵź
							// עڶģͬϵͳ,ֻ趨һ豸Ϊ豸,趨Ϊ豸,ϵͳֻһ豸ж豸ǲҪͬ,轫豸趨Ϊ豸
	LONG SyncTrigSignal;	// ͬԴ
	LONG bClkOutEn;			// ʱǷ,TRUE,(忨8531b 8532b֧)
	LONG ClkOutSel;			// ʱѡ,(忨8531b 8532b֧)
	LONG bTrigOutEn;		// Ƿ,TRUE,(忨8531b 8532b֧)
	LONG TrigOutPolarity;	// ,(忨8531b 8532b֧)
	LONG TrigOutWidth;		// ȵλnS,[50, 50000]50nS
} ACTS1001_PARA_AD, *PACTS1001_PARA_AD;

//***********************************************************
// ADACTS1001_PARA_ADеInputRange[X]ʹõӲѡ
const long ACTS1001_INPUT_N5000_P5000mV		= 0x00; // 5000mV
const long ACTS1001_INPUT_N1000_P1000mV		= 0x01; // 1000mV

// ADACTS1001_PARA_ADеCouplingTypeʹõѡ
const long ACTS1001_COUPLING_DC				= 0x00;	// ֱ
const long ACTS1001_COUPLING_AC				= 0x01;	// 

//***********************************************************
// ADӲACTS1001_PARA_ADеTriggerModeԱʹôģʽѡ
const long ACTS1001_TRIGMODE_POST			= 0x00; // 󴥷
const long ACTS1001_TRIGMODE_DELAY			= 0x01; // Ӳʱ

//***********************************************************
// ADӲACTS1001_PARA_ADеTriggerSourceԴźʹõѡ
const long ACTS1001_TRIGMODE_SOFT			= 0x00; // (ȱʡֵ)
const long ACTS1001_TRIGSRC_DTR				= 0x01; // ⲿִ(DTR)
const long ACTS1001_TRIGSRC_TRIGGER			= 0x02; // ͬźŴ(ڶ࿨ͬ,ź,ֱӲ׽)
const long ACTS1001_TRIGSRC_CH0				= 0x03; // ͨ0
const long ACTS1001_TRIGSRC_CH1				= 0x04; // ͨ1
const long ACTS1001_TRIGSRC_CH2				= 0x05; // ͨ2
const long ACTS1001_TRIGSRC_CH3				= 0x06; // ͨ3

// ADӲACTS1001_PARA_ADеTriggerTypeʹõѡ
const long ACTS1001_TRIGTYPE_EDGE			= 0x00; // ش

//***********************************************************
// ADӲACTS1001_PARA_ADеTriggerDirʹõѡ
const long ACTS1001_TRIGDIR_NEGATIVE		= 0x00; // ½ش
const long ACTS1001_TRIGDIR_POSITIVE		= 0x01; // ش
const long ACTS1001_TRIGDIR_NEGAT_POSIT		= 0x02; // ±ؾ

//***********************************************************
// ADӲACTS1001_PARA_ADеReferenceClockοʱѡʹõѡ
const long ACTS1001_RECLK_ONBOARD			= 0x00; // ʱ(Ĭ)
const long ACTS1001_RECLK_EXT_10M			= 0x01;	// ⲿ10MCLK_IN(忨8531 8532֧)
const long ACTS1001_RECLK_PXI_10M			= 0x02;	// 10M(PCIE)

//***********************************************************
// ADӲACTS1001_PARA_ADеTimeBaseClockʱѡʹõѡ
const long ACTS1001_TBCLK_IN				= 0x00; // ڲʱ(Ĭ)
const long ACTS1001_RECLK_EXT				= 0x01;	// ⲿʱӣCLK_IN(忨8582 8584֧)

//***********************************************************
// ADӲACTS1001_PARA_ADеSyncTrigSignalͬԴʹõѡ
const long ACTS1001_STS_TRIGGER0			= 0x00; // ͬźTRIG0 
const long ACTS1001_STS_TRIGGER1			= 0x01; // ͬźTRIG1 
const long ACTS1001_STS_TRIGGER2			= 0x02; // ͬźTRIG2 
const long ACTS1001_STS_TRIGGER3			= 0x03; // ͬźTRIG3 
const long ACTS1001_STS_TRIGGER4			= 0x04; // ͬźTRIG4 
const long ACTS1001_STS_TRIGGER5			= 0x05; // ͬźTRIG5 
const long ACTS1001_STS_TRIGGER6			= 0x06; // ͬźTRIG6 
const long ACTS1001_STS_TRIGGER7			= 0x07; // ͬźTRIG7 

//***********************************************************
// ADӲACTS1001_PARA_ADеClkOutSelʱѡʹõѡ
const long ACTS1001_CLKOUT_REFERENCE		= 0x00; // οʱ
const long ACTS1001_CLKOUT_TIMEBASE			= 0x01; // ׼ʱ 

//***********************************************************
// ADӲACTS1001_PARA_ADеTrigOutPolarityʱѡʹõѡ
const long ACTS1001_TOP_NEGATIVE			= 0x00; // 
const long ACTS1001_TOP_POSITIVE			= 0x01; //  

// #################### ADҪϢṹ(ACTS1001_AD_MAIN_INFO) #######################
typedef struct _ACTS1001_AD_MAIN_INFO
{
	LONG nDeviceType;			// \豸0x20128514 20118512...2012(PXIE)2011(PCIE)
	LONG nChannelCount;			// ADͨ
	LONG nDepthOfMemory;		// ADش洢(MB)
	LONG nSampResolution;		// ADֱ(=8ʾ8Bit; =12ʾ12Bit; =14ʾ14Bit; =16ʾ16Bit)
	LONG nSampCodeCount;		// AD(256, 4096, 16384, 65536)
	LONG nTrigLvlResolution;	// ƽֱ(=8ʾ8Bit; =12ʾ12Bit; =16ʾ16Bit)
	LONG nTrigLvlCodeCount;		// ƽ(256, 4096)
	LONG nBaseRate;				// ׼ƵHz
	LONG nMaxRate;				// ƵHz
	LONG nMinFreqDivision;		// СƵ
	LONG nSupportImped;			// Ƿ֧迹(0:֧ 1:֧)
	LONG nSupportPFI;			// Ƿ֧PFIѡ(0:֧ 1:֧)
	LONG nSupportExt10M;		// Ƿ֧ⲿ10M(0:֧ 1:֧)
	LONG nSupportExtClk;		// Ƿ֧ʱ(0:֧ 1:֧)
	LONG nSupportPXIE100M;		// Ƿ֧PXIE100M(0:֧ 1:֧)
	LONG nSupportClkOut;		// Ƿ֧ʱ(0:֧ 1:֧)
	LONG nSupportTrigOut;		// Ƿִ֧(0:֧ 1:֧)

	LONG nReserved0;			// ֶ(δ)
	LONG nReserved1;			// ֶ(δ)
	LONG nReserved2;			// ֶ(δ)
} ACTS1001_AD_MAIN_INFO, *PACTS1001_AD_MAIN_INFO;

//***********************************************************
// ûӿ
#ifndef _ACTS1001_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	// ڱ豸
	HANDLE DEVAPI FAR PASCAL ACTS1001_CreateDevice(int DeviceID = 0);		// 豸
	HANDLE DEVAPI FAR PASCAL ACTS1001_CreateDeviceEx(LONG DevicePhysID);		// 豸(úʹID255)
	LONG DEVAPI FAR PASCAL ACTS1001_GetDeviceCount(HANDLE hDevice);			// ȡ豸̨
	BOOL DEVAPI FAR PASCAL ACTS1001_SetDevicePhysID(HANDLE hDevice, LONG DevicePhysID); // õǰ豸ID[0:255]
	BOOL DEVAPI FAR PASCAL ACTS1001_GetDeviceCurrentID(HANDLE hDevice, PLONG DeviceLgcID, PLONG DevicePhysID); // ȡõǰ豸߼IDźID
	BOOL DEVAPI FAR PASCAL ACTS1001_ListDeviceDlg(HANDLE hDevice);			// бϵͳееĸPCI豸
    BOOL DEVAPI FAR PASCAL ACTS1001_ReleaseDevice(HANDLE hDevice);			// ر豸,ֹ,ͷԴ

	//####################### ADݶȡ #################################
	// ڴͨû,Щӿ򵥡ݡɿ,û֪豸
	// Ͳ㸴ӵӲЭͷƱ,ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ
	BOOL DEVAPI FAR PASCAL ACTS1001_GetMainInfo(								// ȡ忨Ϣ
												HANDLE hDevice,					// 豸
												PACTS1001_AD_MAIN_INFO pMainInfo);		// ذ忨Ϣ
	BOOL DEVAPI FAR PASCAL ACTS1001_ADCalibration(								// ADУ׼
												HANDLE hDevice);				// 豸				
    BOOL DEVAPI FAR PASCAL ACTS1001_InitDeviceAD(								// ʼ豸,TRUE,豸̿ʼ.
												HANDLE hDevice,					// 豸
												PACTS1001_PARA_AD pADPara);		// Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL ACTS1001_StartDeviceAD(								// ڳʼ֮,豸
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL ACTS1001_SetDeviceTrigAD(							// 豸ʹ,¼(ֻдԴΪʱЧ)
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL ACTS1001_ReadDeviceAD(								// DMAʽAD
												HANDLE hDevice,					// 豸
												PWORD pADBuffer,				// ڽݵû,׵ַ4096,뽫2048
												ULONG nReadSizeWords,			// ȡ(Ϊ2048)
												PULONG nRetSizeWords,			// ʵʶȡݳ
												PULONG pbFlag,					// ־\Чλ:λΪ1ʾ,16λЧ׵ַƫλ
												double fTimeout);				// 䳬ʱʱ,λS(ڴʱ豸ûݴ伴ᳬʱ,д伴Ż᷵)
								
    BOOL DEVAPI FAR PASCAL ACTS1001_StopDeviceAD(								// 豸֮,ͣ豸
												HANDLE hDevice);				// 豸

	BOOL DEVAPI FAR PASCAL ACTS1001_ReleaseDeviceAD(								// رAD豸,ֹ,ͷԴ
												HANDLE hDevice);				// 豸

	PVOID DEVAPI FAR PASCAL ACTS1001_AllocateBuffer(							// ڴ
												ULONG ulRequsetSize);			// ڴСλֽ

	BOOL DEVAPI FAR PASCAL ACTS1001_FreeBuffer(									// ͷڴ
												PVOID pData);

	//################# ADӲ ########################
	BOOL DEVAPI FAR PASCAL ACTS1001_SaveParaAD(HANDLE hDevice, PACTS1001_PARA_AD pADPara);  
    BOOL DEVAPI FAR PASCAL ACTS1001_LoadParaAD(HANDLE hDevice, PACTS1001_PARA_AD pADPara);
	BOOL DEVAPI FAR PASCAL ACTS1001_ResetParaAD(HANDLE hDevice, PACTS1001_PARA_AD pADPara);

	// ################################ 뺯 ################################
	BOOL DEVAPI FAR PASCAL ACTS1001_SetPassword(ULONG nPassword);
	// ################################ 豸кź ################################
	BOOL DEVAPI FAR PASCAL ACTS1001_SetSerialNum(					// к, ɹʱTRUE,򷵻FALSE(ACTS1001_SetPasswordɹſ)
												HANDLE hDevice,			// 豸,DEV_Create()
												ULONG nSerialNum);		// к

	BOOL DEVAPI FAR PASCAL ACTS1001_GetSerialNum(					// к, ɹʱTRUE,򷵻FALSE
												HANDLE hDevice,			// 豸,DEV_Create()
												ULONG* pSerialNum);		// صк

	BOOL DEVAPI FAR WINAPI ACTS1001_GetBusInfo(						// 豸Ϣ
												HANDLE hDevice,			// 豸,DEV_Create()
												ULONG* pBusNumber,		// ߺ
												ULONG* pFunctionNumber,	// عܺ
												ULONG* pDeviceNumber);	// 豸
	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱ,ûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL ACTS1001_GetDeviceBar(					// ȡָָ豸ĴBARַ
											HANDLE hDevice,			// 豸,CreateDevice
											__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵
	BOOL DEVAPI FAR PASCAL ACTS1001_GetDevVersion(					// ȡ豸̼汾
											HANDLE hDevice,			// 豸,CreateDevice
											PULONG pulFmwVersion,	// ̼汾
											PULONG pulDriverVersion);// 汾
	BOOL DEVAPI FAR PASCAL ACTS1001_WriteRegisterByte(				// 豸ӳĴռָ˿д뵥
											HANDLE hDevice,			// 豸
											__int64 pbLinearAddr,		// ָӳĴԻַ
											ULONG OffsetBytes,		// ڻַƫλ
											BYTE Value);			// ַָд뵥ֽ(ַԻַƫλþ)
	BOOL DEVAPI FAR PASCAL ACTS1001_WriteRegisterWord(				// д˫ֽ(ͬ)
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes,  
											WORD Value);
	BOOL DEVAPI FAR PASCAL ACTS1001_WriteRegisterULong(				// дĽ(ͬ)
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes,  
											ULONG Value);
	BYTE DEVAPI FAR PASCAL ACTS1001_ReadRegisterByte(				// 뵥ֽ(ͬ)
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);
	WORD DEVAPI FAR PASCAL ACTS1001_ReadRegisterWord(				// ˫ֽ(ͬ)
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);
	ULONG DEVAPI FAR PASCAL ACTS1001_ReadRegisterULong(				// ֽ(ͬ)
											HANDLE hDevice, 
											__int64 pbLinearAddr, 
											ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱ,ûʹЩӿʵ֡
	// ЩҪڴͳ豸,ISAߡڡڵ豸,ڱPCI豸
    BOOL DEVAPI FAR PASCAL ACTS1001_WritePortByte(HANDLE hDevice, __int64 pbPort, BYTE Value);
    BOOL DEVAPI FAR PASCAL ACTS1001_WritePortWord(HANDLE hDevice, __int64 pbPort, WORD Value);
    BOOL DEVAPI FAR PASCAL ACTS1001_WritePortULong(HANDLE hDevice, __int64 pbPort, ULONG Value);

    BYTE DEVAPI FAR PASCAL ACTS1001_ReadPortByte(HANDLE hDevice, __int64 pbPort);
    WORD DEVAPI FAR PASCAL ACTS1001_ReadPortWord(HANDLE hDevice, __int64 pbPort);
    ULONG DEVAPI FAR PASCAL ACTS1001_ReadPortULong(HANDLE hDevice, __int64 pbPort);

	//########################### ̲߳ ######################################
	HANDLE DEVAPI FAR PASCAL ACTS1001_CreateSystemEvent(void);			// ں¼,InitDeviceIntVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL ACTS1001_ReleaseSystemEvent(HANDLE hEvent);	// ͷں¼

#ifdef __cplusplus
}
#endif

// Զ
#ifndef _ACTS1001_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "ACTS1001_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with ACTS1001_32.dll...")
		#pragma message("======== Successfully linked with ACTS1001_32.dll")
	#else
		#pragma comment(lib, "ACTS1001_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with ACTS1001_64.dll...")
		#pragma message("======== Successfully linked with ACTS1001_64.dll")
	#endif
	
#endif

#endif // _ACTS1001_DEVICE_
